var AdmZip = require('adm-zip');
var cheerio = require('cheerio');

function epubToText(path) {

  let zip = new AdmZip(path);
  let zipEntries = zip.getEntries(); // an array of ZipEntry records

  // get content.opf path and containing folder
  let $ = cheerio.load( zip.readAsText('META-INF/container.xml') );
  let contentOpfPath = $("container rootfiles rootfile").attr("full-path");
  let contentOpfFolder = contentOpfPath.split("/")
  contentOpfFolder.pop();
  contentOpfFolder = contentOpfFolder.join("");

  // push html/htm files into our array of paths to convert to text
  $ = cheerio.load(  zip.readAsText(contentOpfPath) );
  let contentFilePaths = [];
  $("package manifest item").each((i, el) => {

    let path = $(el).attr("href");
    let pathParts = path.split(".");
    let lastPart = pathParts[pathParts.length-1];

    if(lastPart === "html" || lastPart === "htm") {
      contentFilePaths.push(contentOpfFolder+"/"+path);
    }

  });

  // extract text from each file with cheerio
  let output = "";
  for(let path of contentFilePaths) {

    let $ = cheerio.load( zip.readAsText(path) );
    output += $("body").text();

  }

  return output;

}

module.exports = epubToText;
